<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.5"/>
<title>fw3DViewer: fw3DViewer: JCOP Framework 3D-Viewer widget</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">fw3DViewer
   &#160;<span id="projectnumber">8.4.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.5 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li class="current"><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title"><a class="el" href="classfw3DViewer.html">fw3DViewer</a>: JCOP Framework 3D-Viewer widget </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>The fw3DWidget is a WinCC OA widget for represent 3D graphics The JCOP Framework 3D-Viewer widget is an extension of WinCC OA User Interface allowing to display 3-dimensional view ("scene") made of various geometrical objects. It allows to navigate, and interact with these object making the experience of the user interface very attractive and intuitive.</p>
<div class="image">
<img src="fw3DViewer_demo1.png" alt="fw3DViewer_demo1.png"/>
<div class="caption">
An example of a WinCC OA panel with fw3DViewer displaying a dummy detector</div></div>
<p> It is a WinCC OA EWO (External Widget Object) UI component that could be embedded into any WinCC OA panel. The viewer is generic: the objects displayed in the scene are created and modified using standard WinCC OA scripts, and the interaction (such as clicking in an object) is also scriptable.</p>
<p>This is the initial version of the documentation; we are aware that it lacks the completness and is not giving enough introduction. Please contact the authors if you need more information.</p>
<h1><a class="anchor" id="ShapesTypesScenes"></a>
Shapes, Shape Types and the Scene</h1>
<p>The widget displays the view of a so called "Scene": a volume filled with "Shapes". Each Shape is an instance of a Shape Type; there is a set of shape types that are available in the widget - they are documented below. Each shape is identified (and addressed) by a unique name. Each shape has individual set of properties, which define its geometry (placement, rotation, lenths of edges, radiuses, etc), and visual appearance (colour, transparency)</p>
<p>For instance, a scene may be composed of three cubes: "Cube1", "Cube2", "Cube3", each of which is of type "Box". Each of them may have a different colour, transparency, and placement. Each of them may be moved/changed independently of the others.</p>
<p>When the widget is placed in the panel, its scene is initially empty. It is the role of the panel programmer, to use the functions to add shapes to it. Typically, this should be done in the <code>init</code> script of the widget, or the init script of the panel. By default, when the widget is created, it contains the scene view itself (initially an empty area of navy-blue colour), and a set of additional elements called "decorations". The "decorations" elements are three "wheels" that allow to navigate the scene (two in the bottom-left corner, one in bottom-right corner), and a vertical button bar allowing to change the viewer behaviour. The decorations may be hidden (and later shown) either using the context menu (brought up by a right-click), or using the <a class="el" href="classfw3DViewer.html#a7b2facbc854e4c7264f180864589b826">fw3DViewer::setDecoration</a> function.</p>
<p>Note that a panel may contain more than one instance of <a class="el" href="classfw3DViewer.html">fw3DViewer</a>, and all these instances are independent and may be manipulated independently</p>
<h1><a class="anchor" id="OperationModes"></a>
Modes of operation of the widget, navigating in the scene</h1>
<p>The widget has two modes of operation: <em>"Viewing"</em> and <em>"Picking"</em>.</p>
<p>In the "Viewing" mode, the mouse may be used to navigate in the scene: </p>
<ul>
<li>dragging with left-mouse-button pressed rotates the scene </li>
<li>dragging with middle-mouse-button pressed pans the scene </li>
<li>scrolling-wheel zooms in or zooms out ("dollies") the scene </li>
<li>righ-clicking in the scene brings out a context-menu with 3D-specific settings</li>
</ul>
<p>In the "Picking" mode, the mouse is used to interact with the object. Clicking in the object triggers the <a class="el" href="classfw3DViewer.html#a4c6d6400efc1290faf7175d54df77de5">fw3DViewer::shapeClicked</a> event, which may then be served by a dedicated WinCC OA script. Note that in this mode the navigation in the scene is not possible.</p>
<p>To switch between the "Viewing" and "Picking" mode, the following may be used: </p>
<ul>
<li>the user can press the "Esc" key while the mouse cursor is in the scene </li>
<li>if the widget has "decorations" (additional buttons bar in the right) visible, one can use the button with a "hand" icon to switch to the "Viewing" mode, and the "arrow" button to switch to the "Picking" mode </li>
<li>In the "Viewing" mode, one can right-click to bring up the context menu, and unselect the "Viewing" option to enter the "Picking" mode </li>
<li>From a WinCC OA script, one can use teh <a class="el" href="classfw3DViewer.html#a634d0c5b1fc14201bfceac00779f3803">fw3DViewer::setViewing</a> function to change the mode</li>
</ul>
<p>Navigation in the scene may also be done using the "go to" functionality: it will navigate in the scene (rotate, zoom), so that the desired shape is visible at the center. To navigate to a certain shape, one should use the <a class="el" href="classfw3DViewer.html#a6b866b31758dd4f5da968935113745da">fw3DViewer::seekToShape</a> function, passing the name of the shape to it. One could also use <a class="el" href="classfw3DViewer.html#a0df7d193ec2cfdd91764a1b1893d33cd">fw3DViewer::setSeek</a> to activate the "seek mode"; in the "seek mode", the scene will navigate to a shape that was clicked.</p>
<h1><a class="anchor" id="ShapeTypes"></a>
Available Shape Types and Their Parameters</h1>
<p>The following shape types are available in this release:</p>
<h2><a class="anchor" id="Shape_Box"></a>
Box</h2>
<p>A Box is a cuboid of given half lengths <code>dx</code>, <code>dy</code>, <code>dz</code> . The Box is centred on the origin with sides parallel to the x/y/z axes.</p>
<p>Available Geometry Properties: </p>
<ul>
<li><code>"x"</code>,"y","z" - position of the shape, in x,y,z direction </li>
<li><code>"position"</code> - position of the shape specified as a string of 3 floats (for x, y and z); alternative to the <code>"x"</code>, <code>"y"</code> and <code>"z"</code> properties </li>
<li><code>"rotationMatrix"</code> or <code>"rotation"</code> - 3x3 rotation matrix, passed as a string of 9 float numbers separated by commas; the <code>"rotation"</code> property is now deprecated - it is a synonym of <code>"rotationMatrix"</code> </li>
<li><code>"rotationAngle"</code> - rotation specified by an axis and angle; passed as a string of 4 float numbers: the first three being the vector that defines the axis, the fourth being the rotation angle in radians. <code>"rotationAngle"</code> is an alternative to <code>"rotationMatrix"</code> </li>
<li><code>"dx"</code>,"dy","dz" - half-lengths along the x,y and z axis</li>
</ul>
<p>Example </p>
<div class="fragment"><div class="line">* myShape.addShape(<span class="stringliteral">&quot;Box&quot;</span>,<span class="stringliteral">&quot;MyExampleBox&quot;</span>,</div>
<div class="line">*          makeDynString(<span class="stringliteral">&quot;x&quot;</span>,<span class="stringliteral">&quot;1.0&quot;</span>,</div>
<div class="line">*                        <span class="stringliteral">&quot;y&quot;</span>,<span class="stringliteral">&quot;2.0&quot;</span>,</div>
<div class="line">*                        <span class="stringliteral">&quot;z&quot;</span>,<span class="stringliteral">&quot;3.0&quot;</span>,</div>
<div class="line">*                        <span class="stringliteral">&quot;dx&quot;</span>,<span class="stringliteral">&quot;1.0&quot;</span>,</div>
<div class="line">*                        <span class="stringliteral">&quot;dy&quot;</span>,<span class="stringliteral">&quot;2.0&quot;</span></div>
<div class="line">*                        <span class="stringliteral">&quot;dz&quot;</span>,<span class="stringliteral">&quot;4.0&quot;</span>,</div>
<div class="line">*                        <span class="stringliteral">&quot;rotationMatrix&quot;</span>,<span class="stringliteral">&quot;0.0, 0.0, 1.0, 0.0, 1.0, 0.0, 1.0, 0.0, 0.0&quot;</span></div>
<div class="line">*          )</div>
<div class="line">* );</div>
<div class="line">* </div>
</div><!-- fragment --><h2><a class="anchor" id="Shape_Sphere"></a>
Sphere</h2>
<p>a sphere with radius <code>r</code> </p>
<p>Available Geometry Properties </p>
<ul>
<li><code>"x"</code>,"y","z" - position of the shape </li>
<li><code>"position"</code> - position of the shape specified as a string of 3 floats (for x, y and z); alternative to the <code>"x"</code>, <code>"y"</code> and <code>"z"</code> properties </li>
<li><code>"r"</code> - sphere radius</li>
</ul>
<h2><a class="anchor" id="Shape_Cone"></a>
Cone</h2>
<p>a Phi segment of a cone, with half-length <code>dz</code>, inner and outer radii specified at <code>-dz</code> and <code>+dz</code>. The Phi segment is described by a starting <code>startphi</code> angle, and the <code>deltaphi</code> delta angle for the shape. If the delta angle is &gt;=2*M_PI, the shape is treated as continuous in Phi.</p>
<p>Available Geometry Properties </p>
<ul>
<li><code>"x"</code>,"y","z" - position of the shape </li>
<li><code>"position"</code> - position of the shape specified as a string of 3 floats (for x, y and z); alternative to the <code>"x"</code>, <code>"y"</code> and <code>"z"</code> properties </li>
<li><code>"rotationMatrix"</code> or <code>"rotation"</code> - 3x3 rotation matrix, passed as a string of 9 float numbers separated by commas; the <code>"rotation"</code> property is now deprecated - it is a synonym of <code>"rotationMatrix"</code> </li>
<li><code>"rotationAngle"</code> - rotation specified by an axis and angle; passed as a string of 4 float numbers: the first three being the vector that defines the axis, the fourth being the rotation angle in radians. <code>"rotationAngle"</code> is an alternative to <code>"rotationMatrix"</code> </li>
<li><code>"dz"</code> - half-length in z </li>
<li><code>"radiusMin"</code> - inside radius at -dz. </li>
<li><code>"radiusMax"</code> - ouside radius at -dz. </li>
<li><code>"radiusMin2"</code> - inside radius at +dz. </li>
<li><code>"radiusMax2"</code> - outside radius at +dz. </li>
<li><code>"startPhi"</code> - starting angle of the segment in radians. </li>
<li><code>"deltaPhi"</code> - delta angle of the segment in radians.</li>
</ul>
<h2><a class="anchor" id="Shape_Tube"></a>
Tube</h2>
<p>A tube or tube segment with curved sides parallel to the z-axis.</p>
<p>The tube has a specified half-length along the z axis, about which it is centred, and a given minimum and maximum radius. A minimum radius of 0 signifies a filled tube /cylinder. The tube segment is specified by starting and delta angles for phi, with 0 being the +x axis, PI/2 the +y axis. A delta angle of 2PI signifies a complete, unsegmented tube/cylinder.</p>
<p>Available Geometry Properties: </p>
<ul>
<li><code>"x"</code>,"y","z" - position of the shape </li>
<li><code>"position"</code> - position of the shape specified as a string of 3 floats (for x, y and z); alternative to the <code>"x"</code>, <code>"y"</code> and <code>"z"</code> properties </li>
<li><code>"rotationMatrix"</code> or <code>"rotation"</code> - 3x3 rotation matrix, passed as a string of 9 float numbers separated by commas; the <code>"rotation"</code> property is now deprecated - it is a synonym of <code>"rotationMatrix"</code> </li>
<li><code>"rotationAngle"</code> - rotation specified by an axis and angle; passed as a string of 4 float numbers: the first three being the vector that defines the axis, the fourth being the rotation angle in radians. <code>"rotationAngle"</code> is an alternative to <code>"rotationMatrix"</code> </li>
<li><code>"dz"</code> - half-length in z </li>
<li><code>"radiusMin"</code> - inside radius of the tube. </li>
<li><code>"radiusMax"</code> - outside radius of the tube. </li>
<li><code>"startPhi"</code> - starting angle, in radians. </li>
<li><code>"deltaPhi"</code> - delta-angle, in radians.</li>
</ul>
<h2><a class="anchor" id="Shape_Trd"></a>
Trd</h2>
<p>A Trd is a trapezoid with the x and y dimensions varying along z.</p>
<p>Available Geometry Properties: </p>
<ul>
<li><code>"x"</code>,"y","z" - position of the shape </li>
<li><code>"position"</code> - position of the shape specified as a string of 3 floats (for x, y and z); alternative to the <code>"x"</code>, <code>"y"</code> and <code>"z"</code> properties </li>
<li><code>"rotationMatrix"</code> or <code>"rotation"</code> - 3x3 rotation matrix, passed as a string of 9 float numbers separated by commas; the <code>"rotation"</code> property is now deprecated - it is a synonym of <code>"rotationMatrix"</code> </li>
<li><code>"rotationAngle"</code> - rotation specified by an axis and angle; passed as a string of 4 float numbers: the first three being the vector that defines the axis, the fourth being the rotation angle in radians. <code>"rotationAngle"</code> is an alternative to <code>"rotationMatrix"</code> </li>
<li><code>"dz"</code> - half-length in z </li>
<li><code>"dx"</code> - half-length of x, at -dz. </li>
<li><code>"dx2"</code> - half-length of x, at +dz. </li>
<li><code>"dy"</code> - half-length of y, at -dz. </li>
<li><code>"dy2"</code> - half-length of y, at +dz.</li>
</ul>
<h2><a class="anchor" id="Shape_Trapezoid"></a>
Trapezoid</h2>
<p>general trapezoid: The faces perpendicular to the z planes are tapezia, and their centres are not necessarily on a line parallel to the z axis.</p>
<p>Available Geometry Properties: </p>
<ul>
<li><code>"x"</code>,"y","z" - position of the shape </li>
<li><code>"position"</code> - position of the shape specified as a string of 3 floats (for x, y and z); alternative to the <code>"x"</code>, <code>"y"</code> and <code>"z"</code> properties </li>
<li><code>"rotationMatrix"</code> or <code>"rotation"</code> - 3x3 rotation matrix, passed as a string of 9 float numbers separated by commas; the <code>"rotation"</code> property is now deprecated - it is a synonym of <code>"rotationMatrix"</code> </li>
<li><code>"rotationAngle"</code> - rotation specified by an axis and angle; passed as a string of 4 float numbers: the first three being the vector that defines the axis, the fourth being the rotation angle in radians. <code>"rotationAngle"</code> is an alternative to <code>"rotationMatrix"</code> </li>
<li><code>"dz"</code> - half-length in z </li>
<li><code>"theta"</code> - polar angle of the line joining the centres of the faces at -/+dz. </li>
<li><code>"phi"</code> - azimuthal angle of the line joing the centre of the face at -dz to the centre of the face at +dz. </li>
<li><code>"h1"</code> - half-length along y of the face at -dz. </li>
<li><code>"h2"</code> - half-length along y of the face at +dz. </li>
<li><code>"bl1"</code> - half-length along x of the side at y=-h1 of the face at -dz. </li>
<li><code>"bl2"</code> - half-length along x of the side at y=-h1 of the face at +dz. </li>
<li><code>"tl1"</code> - half-length along x of the side at y=+h1 of the face at -dz. </li>
<li><code>"tl2"</code> - half-length along x of the side at y=+h1 of the face at +dz. </li>
<li><code>"alp1"</code> - Angle with respect to the y axis from the centre of the side at y=-h1 to the centre at y=+h1 of the face at -dz. </li>
<li><code>"alp2"</code> -Angle with respect to the y axis from the centre of the side at y=-h1 to the centre at y=+h1 of the face at +dz.</li>
</ul>
<h2><a class="anchor" id="Shape_text"></a>
Text (Label)</h2>
<p>Shape for visualizing 2D text aligned with the camera plane. The text is not scaled according to the distance from the camera, and is not influenced by rotation or scaling as 3D primitives are.</p>
<p>Both names: "Text" and "Label" are accepted</p>
<p>Available Geometry Properties: </p>
<ul>
<li><code>"x"</code>,"y","z" - position of the shape </li>
<li><code>"position"</code> - position of the shape specified as a string of 3 floats (for x, y and z); alternative to the <code>"x"</code>, <code>"y"</code> and <code>"z"</code> properties </li>
<li><code>"text"</code> - string with text to write </li>
<li><code>"fontname"</code> - The font name is recognized with the form "family:style". The range of supported font families depends on which fonts are installed on the system. A typical font family might be "arial" or "times". Style is either <code>"bold"</code>, <code>"italic"</code> or <code>"bold italic"</code>. </li>
<li><code>"fontsize"</code> - integer with the size of the font, in pixels.</li>
</ul>
<h2><a class="anchor" id="Shape_textFlat"></a>
TextFlat</h2>
<p>Shape for visualizing a flat text (without depth), yet in 3D. Conversely to the <code>Text</code> (<code>Label</code>), the <code>TextFlat</code> shapes are scaled according to camera position, and influenced by rotation and scaling primitives</p>
<p>Available Geometry Properties: </p>
<ul>
<li><code>"x"</code>,"y","z" - position of the shape </li>
<li><code>"position"</code> - position of the shape specified as a string of 3 floats (for x, y and z); alternative to the <code>"x"</code>, <code>"y"</code> and <code>"z"</code> properties </li>
<li><code>"text"</code> - string with text to write </li>
<li><code>"fontname"</code> - The font name is recognized with the form "family:style". The range of supported font families depends on which fonts are installed on the system. A typical font family might be "arial" or "times". Style is either <code>"bold"</code>, <code>"italic"</code> or <code>"bold italic"</code>. </li>
<li><code>"fontsize"</code> - integer with the size of the font, in pixels.</li>
</ul>
<h2><a class="anchor" id="Shape_text3D"></a>
Text3D</h2>
<p>Shape for visualizing a 3D text. Conversely to the <code>Text</code> (<code>Label</code>), the <code>TextFlat</code> shapes are scaled according to camera position, and influenced by rotation and scaling primitives</p>
<p>Available Geometry Properties: </p>
<ul>
<li><code>"x"</code>,"y","z" - position of the shape </li>
<li><code>"position"</code> - position of the shape specified as a string of 3 floats (for x, y and z); alternative to the <code>"x"</code>, <code>"y"</code> and <code>"z"</code> properties </li>
<li><code>"text"</code> - string with text to write </li>
<li><code>"fontname"</code> - The font name is recognized with the form "family:style". The range of supported font families depends on which fonts are installed on the system. A typical font family might be "arial" or "times". Style is either <code>"bold"</code>, <code>"italic"</code> or <code>"bold italic"</code>. </li>
<li><code>"fontsize"</code> - integer with the size of the font, in pixels.</li>
</ul>
<h2><a class="anchor" id="Shape_axis"></a>
Axis</h2>
<p>Shape that represents a coordinate axis.</p>
<p>Available Geometry Properties: </p>
<ul>
<li><code>"x"</code>,"y","z" - position of the shape </li>
<li><code>"position"</code> - position of the shape specified as a string of 3 floats (for x, y and z); alternative to the <code>"x"</code>, <code>"y"</code> and <code>"z"</code> properties </li>
<li><code>"ndiv"</code> - integer with number of divisions in each axis. </li>
<li><code>"divlength"</code> - float with the size of each division.</li>
</ul>
<h2><a class="anchor" id="Shape_Polyhedra"></a>
Polyhedra</h2>
<p>Shape that represents a polyhedron.</p>
<p>Available Geometry Properties: </p>
<ul>
<li><code>"x"</code>,"y","z" - position of the shape </li>
<li><code>"position"</code> - position of the shape specified as a string of 3 floats (for x, y and z); alternative to the <code>"x"</code>, <code>"y"</code> and <code>"z"</code> properties </li>
<li><code>"startphi"</code> - initial phi. </li>
<li><code>"deltaphi"</code> - delta phi. </li>
<li><code>"npdv"</code> - number of steps along phi. </li>
<li><code>"zsections"</code> - string with a list of z planes. The format is: <code>"z,radiusmin,radiusmax,z,radiusmin,radiusmax,z..."</code>.</li>
</ul>
<h1><a class="anchor" id="propmods"></a>
Getting/ modifying shape properties</h1>
<p>The properties (geometrical and visual) of each object can be modified using a set of provided functions.</p>
<p>To move the shape to another position, or change its geometry, or rotation, one may use <a class="el" href="classfw3DViewer.html#ae112a47402bd30a308ff6c77f20cbb19">fw3DViewer::setGeometry</a></p>
<p>To change the color of the shape, use <a class="el" href="classfw3DViewer.html#aeb28a3a47bdb3028e3c03c8c33b8a104">fw3DViewer::setColor</a> or <a class="el" href="classfw3DViewer.html#af59f9140f4dff4c24f3ddc3abd3d3370">fw3DViewer::setColorRGB</a></p>
<p>To change the transparency of the shape, use <a class="el" href="classfw3DViewer.html#ac9191f4b6ea597a97e1cdfc6cd5c3b4d">fw3DViewer::setTransparency</a></p>
<p>To get the properties of a shape one could use the <a class="el" href="classfw3DViewer.html#aeb6c6b8645b33ed51d2cf38da4cb62f5">fw3DViewer::getShapeInfo</a> function, passing the list of properties names to be queried as a parameter.</p>
<h1><a class="anchor" id="grouping"></a>
Grouping of objects</h1>
<p>The objects may be put in the groups. By default, if they are created using the <a class="el" href="classfw3DViewer.html#a7a0f58cbe015dcc91e4e214f548fa528">fw3DViewer::addShape</a> function, they are put in a flat structure, in the toplevel (default) group called <code>"root"</code> .</p>
<p>One may create other groups using the <a class="el" href="classfw3DViewer.html#a1612ccb1ca2f986c8d5bd0a44c31579c">fw3DViewer::addGroup</a> function, then add objects to a specific group by using <a class="el" href="classfw3DViewer.html#a2fd6929e0b24f649711a2d885bc76a19">fw3DViewer::addShapeInGroup</a> . Note that <a class="el" href="classfw3DViewer.html#a1612ccb1ca2f986c8d5bd0a44c31579c">fw3DViewer::addGroup</a> allows to have nested groups.</p>
<p>The grouping of the object allows to change the properties of many objects at once in a simple way. One may use the group name instead of a shape name in functions such as <a class="el" href="classfw3DViewer.html#aeb28a3a47bdb3028e3c03c8c33b8a104">fw3DViewer::setColor</a> or <a class="el" href="classfw3DViewer.html#ac9191f4b6ea597a97e1cdfc6cd5c3b4d">fw3DViewer::setTransparency</a> , and the properties of all members of a group will be changed. This allows, for instance, to hide a big part of the scene, containing a lot of elements, by setting the transparency of the group containing all these objects to 100%.</p>
<p>Note that an object may not simply be moved from one group to another</p>
<h1><a class="anchor" id="deleting"></a>
Deleting the objects, cleaning the scene</h1>
<p>One may delete an existing object using <a class="el" href="classfw3DViewer.html#a9814e06b6758f8fd02ebde86dd991f9f">fw3DViewer::delShape</a> function. To clean the complete scene, one may specify the name of the toplevel group ("root") as the parameter, i.e. </p>
<div class="fragment"><div class="line">* myShape.delShape(<span class="stringliteral">&quot;root&quot;</span>);</div>
<div class="line">* </div>
</div><!-- fragment --> </div></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.5
</small></address>
</body>
</html>
